using OfficeOpenXml;
using System.Data.SQLite;
using System.Diagnostics;

namespace AsmrManage
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        private void Button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Title = "ѡϵxlsxļ";
            openFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Desktop);
            openFileDialog1.Filter = "Excelļ|*.xlsx|ļ|*.*";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox1.Text = openFileDialog1.FileName;
            }

        }

        private void Button2_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();
            folderBrowserDialog1.UseDescriptionForTitle = true;
            folderBrowserDialog1.Description = "ѡ񱣴λ";
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox2.Text = folderBrowserDialog1.SelectedPath;
            }
        }

        private void Log(string message)
        {
            logBox1.AppendText(message + Environment.NewLine);
            logBox1.ScrollToCaret();
        }

        private void Button3_Click(object sender, EventArgs e)
        {
            Log("ʼ");
            string excelFilePath = textBox1.Text;
            string? databaseLocation;
            if (checkBox2.Checked)
            {
                databaseLocation = Path.GetDirectoryName(excelFilePath);
            }
            else
            {
                databaseLocation = textBox2.Text;
            }
            
            if (string.IsNullOrEmpty(excelFilePath) || string.IsNullOrEmpty(databaseLocation))
            {
                Log("TextBox1  TextBox2 Ϊգ޷");
                return;
            }
            string databaseFileName = "asmr.db";
            string databasePath = Path.Combine(databaseLocation, databaseFileName);
            Log($"Դļ:{excelFilePath}\nļ:{databasePath}");
            FileInfo fileInfo = new FileInfo(excelFilePath);

            string? password = null;

            if (checkBox4.Checked)// ļ뱣
            {
                Log("ļ뱣");
                password = textBox3.Text;
            }

            if (!File.Exists(databasePath))
            {
                Log("ĿDBļڣ׼");
                SQLiteConnection.CreateFile(databasePath);
            }
            else
            {
                if (checkBox1.Checked) //allow override
                {
                    Log("ļѴڣ15s󸲸Ѵڵļ練뼰ʱ");
                    Task.Delay(15000).Wait(); // ʱ15
                    File.Delete(databasePath);
                    SQLiteConnection.CreateFile(databasePath);
                }
                else
                {
                    Log("ļѴڣǰ趨ļ˳");
                    return;
                }
            }

            string connectionString = $"Data Source={databasePath};Version=3;";

            Task.Run(() =>
            {
                try
                {
                    using (ExcelPackage package = new ExcelPackage(fileInfo, password))
                    {
                        using (SQLiteConnection connection = new SQLiteConnection(connectionString))
                        {
                            connection.Open();

                            foreach (var worksheet in package.Workbook.Worksheets)
                            {
                                string tableName = worksheet.Name;
                                BeginInvoke((Action)(() =>
                                {
                                    Log($"ʼ{tableName}");
                                }));


                                // һ洢
                                string createTableQuery = $"CREATE TABLE IF NOT EXISTS {tableName} (asmr_id TEXT, asmr_order_id INTEGER)";
                                using (SQLiteCommand command = new SQLiteCommand(createTableQuery, connection))
                                {
                                    command.ExecuteNonQuery();
                                }

                                int rowCount = worksheet.Dimension.Rows;

                                for (int row = 2; row <= rowCount; row++) // ӵڶпʼһǱͷ
                                {
                                    string? asmr_id = worksheet.Cells[row, 1].Value?.ToString();
                                    int asmr_order_id = Convert.ToInt32(worksheet.Cells[row, 2].Value);

                                    string insertDataQuery = $"INSERT INTO {tableName} (asmr_id, asmr_order_id) VALUES (@asmr_id, @asmr_order_id)";

                                    using (SQLiteCommand insertCommand = new SQLiteCommand(insertDataQuery, connection))
                                    {
                                        insertCommand.Parameters.AddWithValue("@asmr_id", asmr_id);
                                        insertCommand.Parameters.AddWithValue("@asmr_order_id", asmr_order_id);

                                        insertCommand.ExecuteNonQuery();
                                    }
                                }
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    BeginInvoke((Action)(() =>
                    {
                        Log($"ERROR: {ex}");
                    }));
                    return;
                }
                BeginInvoke((Action)(() =>
                {
                    Log("SUCCESS");
                }));
                if (checkBox3.Checked)
                {
                    Process.Start("explorer.exe", databaseLocation);
                }
            });
        }
        private void CheckBox2_CheckedChanged(object sender, EventArgs e)
        {
            textBox2.Enabled = !checkBox2.Checked;
        }
        private void CheckBox4_CheckedChanged(object sender, EventArgs e)
        {
            textBox3.ReadOnly = !checkBox4.Checked;
        }


    }
}